﻿#include <Constants.au3>
#include <CommInterface.au3>

;
; AutoIt Version: 3.0
; Language:       English
; Platform:       Windows
; Author:         Mitutoyo Cesko s.r.o., Martin Marusak, m.marusak@mitutoyo.cz
;
; NOTE:			  1) Change value $iPort (row 17) to the real port number on your computer
;				  2) Check properly COM port setting in the section ENVIRONMENT INIT
;
; To program stop:   use Shift+Alt+k keypress

; ENVIRONMENT INIT
; -----------------------------------------------------------------------------------
Local Const $iPort = 1      ; IMPORTANT: PORT NUMBER MUST BE < 10 (espec. for Windows10)
Local Const $iBaud = 9600
Local Const $iParity = 0
Local Const $iByteSize = 8
Local Const $iStopBits = "1"

; Hotkey definition for program end
HotKeySet("+!k", "HotKeyPressed") ; Shift-Alt-k
; -----------------------------------------------------------------------------------

MsgBox(0, "AutoIt", "S T A R T", 1)

Local $hFileSerial =_CommAPI_OpenCOMPort($iPort, $iBaud, $iParity, $iByteSize, $iStopBits)
If @error Then
	MsgBox($MB_SYSTEMMODAL, "COM port error", "Error by attempt to open COM port " & $iPort)
	MsgBox($MB_SYSTEMMODAL, "COM port error", $hFileSerial)
	Exit
EndIf

_CommAPI_ClearCommError($hFileSerial)
_CommAPI_PurgeComm($hFileSerial) ;Clear port (buffer, etc.)

While 1
	$sResult = _CommAPI_ReceiveString($hFileSerial, 300, 0, "@CRLF")
	$sResultArray = StringSplit ($sResult, @CRLF, 1)
	
	$sResultLine = ""
	
	if StringLen($sResult) > 0 Then
		
		;MsgBox(0, "Trace 1", StringLen($sResult))
		
		For $i = 1 to $sResultArray[0]
			; Decimal separator replace from . to ,
			; EXAMPLE: "45.25" -> "45,25"
			; NOTE: if you do not want change the decimal point to the comma, comment next program line.
			$sResultLine = StringReplace($sResultArray[$i], ".", ",")
			$sResultLine = StringStripWS($sResultLine, $STR_STRIPALL)  ; strip all white spaces
			; MsgBox(0, "RS232", $i)
			
			if StringLen($sResultLine) > 0 Then
				;MsgBox(0, "Trace 2", StringLen($sResultLine))
				;type text to cursor position
				Send($sResultLine & "{ENTER}")
			EndIf
		Next

	EndIf
WEnd

MsgBox(0, "AutoIt", "E N D", 1)
_CommAPI_ClosePort($hFileSerial)

; -----------------------------------------------------------------------------------
Func HotKeyPressed()
	MsgBox(0, "AutoIt", "E N D", 1)
	_CommAPI_ClosePort($hFileSerial)
	Exit
EndFunc